{    var   : }
{ M, N }
Unit MNAVR_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, ASH1R_p;

procedure MNAVR(FUNC :Proc_F6_MN; var M :Integer; var N :Integer;
                NSIG :Integer; EPS :Real; DELTA :Real; MAXFN :Integer;
                IOPT :Integer; var PARM :Array of Real;
                var X :Array of Real; var SSQ :Real;
                var F :Array of Real; var XJAC :Array of Real;
                IXJAC :Integer; var XJTJ :Array of Real;
                var WORK :Array of Real; var INFER :Integer;
                var IER :Integer);

implementation

procedure MNAVR(FUNC :Proc_F6_MN; var M :Integer; var N :Integer;
                NSIG :Integer; EPS :Real; DELTA :Real; MAXFN :Integer;
                IOPT :Integer; var PARM :Array of Real;
                var X :Array of Real; var SSQ :Real;
                var F :Array of Real; var XJAC :Array of Real;
                IXJAC :Integer; var XJTJ :Array of Real;
                var WORK :Array of Real; var INFER :Integer;
                var IER :Integer);
var
I,IBAD,IBAD1J,ICAL1I,ICAL1J,ICOUNT,IDELX1,IDELXL,IDELXU,IELX1I,IELX1J,
   IEVAL,IFML,IFML1,IFML1I,IFPL,IFPL1,IFPL1I,IFPU,IGRAD1,IGRADL,
   IGRADU,IJAC,IM,INEW1J,IR,IRAD1I,IRI,IS_,ISCAL1,ISCALL,ISCALU,ISW,
   ITER,IXBAD1,IXNEW1,IXNEWL,IZERO,J,JS,K,KI,L,LI :Integer;
AL,CONS2,DELTA2,DNORM,DSQ,ERL2,ERL2X,FO,FOSQ,FOSQS4,G,HH,ONESFO,PREC,
   REL,RELCON,RHH,SQDIF,SSQOLD,SUM,UP,XDABS,XDIF,XHOLD :Real;
const
SIG :Real = 6.3;
AX :Real = 0.1;
P01 :Real = 0.01;
TENTH :Real = 0.1;
HALF :Real = 0.5;
ZERO :Real = 0.0;
ONE :Real = 1.0;
ONEP5 :Real = 1.5;
TWO :Real = 2.0;
TEN :Real = 10.0;
HUNTW :Real = 1.2E2;
ONEP10 :Real = 1.0E10;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220,_230,_240,_250,_260,_270,_280,_290,
_300,_310,_320,_330,_340,_350,_360,_370,_380,_390,_400,_410,_420,_430,
_440,_450,_460,_470,_480,_490,_500,_510,_520,_530,_540,_550,_560,_570,
_580,_590,_600,_610,_620,_630,_640,_650,_660,_670,_680,_690,_700;
begin
IER := 0;
if ( M <=  0 ) or (  N <=  0 ) or (  IOPT <  0 ) or (  IOPT >  2 )
 then goto _620;
if ( IOPT <>  2 ) 
 then goto _10;
if ( PARM[1] <=  ONE ) or (  PARM[0] <=  ZERO ) 
 then goto _620;
_10:
PREC := Power(TEN,-SIG - ONE);
REL := Power(TEN,-SIG*HALF);
RELCON := Power(TEN,-NSIG);
IGRAD1 := ((N + 1)*N) div 2;
IGRADL := IGRAD1 + 1;
IGRADU := IGRAD1 + N;
IDELX1 := IGRADU;
IDELXL := IDELX1 + 1;
IDELXU := IDELX1 + N;
ISCAL1 := IDELXU;
ISCALL := ISCAL1 + 1;
ISCALU := ISCAL1 + N;
IXNEW1 := ISCALU;
IXNEWL := IXNEW1 + 1;
IXBAD1 := IXNEW1 + N;
IFPL1 := IXBAD1 + N;
IFPL := IFPL1 + 1;
IFPU := IFPL1 + M;
IFML1 := IFPU;
IFML := IFML1 + 1;
AL := ONE;
CONS2 := TENTH;
if ( IOPT =  0 ) 
 then goto _40;
if ( IOPT =  1 ) 
 then goto _20;
AL := PARM[0];
FO := PARM[1];
UP := PARM[2];
CONS2 := PARM[3]*HALF;
goto _30;
_20:
AL := P01;
FO := TWO;
UP := HUNTW;
_30:
ONESFO := ONE/FO;
FOSQ := FO*FO;
FOSQS4 := IntPower(FOSQ,4);
_40:
IEVAL := 0;
DELTA2 := DELTA*HALF;
ERL2 := ONEP10;
IBAD := -99;
ISW := 1;
ITER := -1;
INFER := 0;
IER := 0;
for J:=IDELXL to IDELXU do
 begin
  WORK[J-1] := ZERO;
_50:
 end;
goto _340;
_60:
SSQOLD := SSQ;
if ( INFER >  0 ) or (  IJAC >=  N ) or (  IOPT =  0 ) or ( 
     ICOUNT >  0 ) 
 then goto _110;
IJAC := IJAC + 1;
DSQ := ZERO;
for J:=IDELXL to IDELXU do
 begin
  DSQ := DSQ + WORK[J-1]*WORK[J-1];
_70:
 end;
if ( DSQ <=  ZERO ) 
 then goto _110;
for I:=1 to M do
 begin
  IFML1I := IFML1 + I;
  G := F[I-1] - WORK[IFML1I-1];
  K := I;
  for J:=IDELXL to IDELXU do
   begin
    G := G + XJAC[K-1]*WORK[J-1];
    K := K + M;
_80:
   end;
  G := G/DSQ;
  K := I;
  for J:=IDELXL to IDELXU do
   begin
    XJAC[K-1] := XJAC[K-1] - G*WORK[J-1];
    K := K + M;
_90:
   end;
_100:
 end;
goto _160;
_110:
IJAC := 0;
K := 0;
for J:=1 to N do
 begin
  XDABS := Abs(X[J-1]);
  HH := REL*(EMax1(XDABS,AX));
  XHOLD := X[J-1];
  X[J-1] := X[J-1] + HH;
  FUNC(X,M,N,WORK[IFPL-1]);
  IEVAL := IEVAL + 1;
  X[J-1] := XHOLD;
  if ( ISW =  1 ) 
   then goto _130;
  X[J-1] := XHOLD - HH;
  FUNC(X,M,N,WORK[IFML-1]);
  IEVAL := IEVAL + 1;
  X[J-1] := XHOLD;
  RHH := HALF/HH;
  for I:=IFPL to IFPU do
   begin
    K := K + 1;
    IM := I + M;
    XJAC[K-1] := (WORK[I-1] - WORK[IM-1])*RHH;
_120:
   end;
  goto _150;
_130:
  RHH := ONE/HH;
  for I:=1 to M do
   begin
    K := K + 1;
    IFPL1I := IFPL1 + I;
    XJAC[K-1] := (WORK[IFPL1I-1] - F[I-1])*RHH;
_140:
   end;
_150:
 end;
_160:
ERL2X := ERL2;
ERL2 := ZERO;
K := 0;
for J:=IGRADL to IGRADU do
 begin
  SUM := ZERO;
  for I:=1 to M do
   begin
    K := K + 1;
    SUM := SUM + XJAC[K-1]*F[I-1];
_170:
   end;
  WORK[J-1] := SUM;
  ERL2 := ERL2 + SUM*SUM;
_180:
 end;
ERL2 := Sqrt(ERL2);
if ( IJAC >  0 ) 
 then goto _190;
if ( ERL2 <=  DELTA2 ) 
 then INFER := INFER + 4;
if ( ERL2 <=  CONS2 ) 
 then ISW := 2;
_190:
L := 0;
IS_ := -M;
for I:=1 to N do
 begin
  IS_ := IS_ + M;
  JS := 0;
  for J:=1 to I do
   begin
    L := L + 1;
    SUM := ZERO;
    for K:=1 to M do
     begin
      LI := IS_ + K;
      JS := JS + 1;
      SUM := SUM + XJAC[LI-1]*XJAC[JS-1];
_200:
     end;
    XJTJ[L-1] := SUM;
_210:
   end;
_220:
 end;
if ( INFER >  0 ) 
 then goto _640;
if ( IEVAL >=  MAXFN ) 
 then goto _590;
if ( IOPT =  0 ) 
 then goto _240;
K := 0;
for J:=1 to N do
 begin
  K := K + J;
  ICAL1J := ISCAL1 + J;
  WORK[ICAL1J-1] := XJTJ[K-1];
_230:
 end;
goto _270;
_240:
DNORM := ZERO;
K := 0;
for J:=1 to N do
 begin
  K := K + J;
  ICAL1J := ISCAL1 + J;
  WORK[ICAL1J-1] := Sqrt(XJTJ[K-1]);
  DNORM := DNORM + XJTJ[K-1]*XJTJ[K-1];
_250:
 end;
DNORM := ONE/Sqrt(DNORM);
for J:=ISCALL to ISCALU do
 begin
  WORK[J-1] := WORK[J-1]*DNORM*ERL2;
_260:
 end;
_270:
ICOUNT := 0;
_280:
K := 0;
for I:=1 to N do
 begin
  for J:=1 to I do
   begin
    K := K + 1;
    WORK[K-1] := XJTJ[K-1];
_290:
   end;
  ICAL1I := ISCAL1 + I;
  WORK[K-1] := WORK[K-1] + WORK[ICAL1I-1]*AL;
  IELX1I := IDELX1 + I;
  IRAD1I := IGRAD1 + I;
  WORK[IELX1I-1] := WORK[IRAD1I-1];
_300:
 end;
_310:
ASH1R(WORK,WORK[IDELXL-1],WORK[IXNEWL-1],N,1,IER);
for J:=1 to N do
 begin
  IELX1J := IDELX1 + J;
  INEW1J := IXNEW1 + J;
  WORK[IELX1J-1] := WORK[INEW1J-1];
_320:
 end;
if ( IER =  0 ) 
 then goto _330;
IER := 0;
if ( IJAC >  0 ) 
 then goto _110;
if ( IBAD <=  0 ) 
 then goto _490;
if ( IBAD >=  2 ) 
 then goto _630;
goto _390;
_330:
if ( IBAD <>  -99 ) 
 then IBAD := 0;
_340:
for J:=1 to N do
 begin
  IELX1J := IDELX1 + J;
  INEW1J := IXNEW1 + J;
  WORK[INEW1J-1] := X[J-1] - WORK[IELX1J-1];
_350:
 end;
FUNC(WORK[IXNEWL-1],M,N,WORK[IFPL-1]);
IEVAL := IEVAL + 1;
SSQ := ZERO;
for I:=IFPL to IFPU do
 begin
  SSQ := SSQ + WORK[I-1]*WORK[I-1];
_360:
 end;
if ( ITER >=  0 ) 
 then goto _380;
ITER := 0;
SSQOLD := SSQ;
for I:=1 to M do
 begin
  IFPL1I := IFPL1 + I;
  F[I-1] := WORK[IFPL1I-1];
_370:
 end;
goto _110;
_380:
if ( IOPT =  0 ) 
 then goto _440;
if ( SSQ <=  SSQOLD ) 
 then goto _420;
_390:
ICOUNT := ICOUNT + 1;
AL := AL*FOSQ;
if ( IJAC =  0 ) 
 then goto _400;
if ( ICOUNT >=  4 ) or (  AL >  UP ) 
 then goto _410;
_400:
if ( AL <=  UP ) 
 then goto _280;
if ( IBAD =  1 ) 
 then goto _630;
goto _610;
_410:
AL := AL/FOSQS4;
goto _110;
_420:
if ( ICOUNT =  0 ) 
 then AL := AL/FO;
if ( ERL2X <=  ZERO ) 
 then goto _430;
G := ERL2/ERL2X;
if ( ERL2 <  ERL2X ) 
 then AL := AL*EMax1(ONESFO,G);
if ( ERL2 >  ERL2X ) 
 then AL := AL*EMin1(FO,G);
_430:
AL := EMax1(AL,PREC);
_440:
ITER := ITER + 1;
for J:=1 to N do
 begin
  INEW1J := IXNEW1 + J;
  X[J-1] := WORK[INEW1J-1];
_450:
 end;
for I:=1 to M do
 begin
  IFML1I := IFML1 + I;
  WORK[IFML1I-1] := F[I-1];
  IFPL1I := IFPL1 + I;
  F[I-1] := WORK[IFPL1I-1];
_460:
 end;
if ( ICOUNT >  0 ) or (  IJAC >  0 ) 
 then goto _60;
for J:=1 to N do
 begin
  IELX1J := IDELX1 + J;
  XDIF := Abs(WORK[IELX1J-1])/EMax1(Abs(X[J-1]),AX);
  if ( XDIF >  RELCON ) 
   then goto _480;
_470:
 end;
INFER := 1;
_480:
SQDIF := Abs(SSQ-SSQOLD)/EMax1(SSQOLD,AX);
if ( SQDIF <=  EPS ) 
 then INFER := INFER + 2;
goto _60;
_490:
if ( IBAD ) < 0
 then goto _520
 else if ( IBAD ) > 0
       then goto _540
       else goto _500;
_500:
for J:=1 to N do
 begin
  IBAD1J := IXBAD1 + J;
  XHOLD := WORK[IBAD1J-1];
  if ( Abs(X[J-1] - XHOLD) >  RELCON*EMax1(AX,Abs(XHOLD)) )
   then goto _520;
_510:
 end;
goto _600;
_520:
for J:=1 to N do
 begin
  IBAD1J := IXBAD1 + J;
  WORK[IBAD1J-1] := X[J-1];
_530:
 end;
IBAD := 1;
_540:
if ( IOPT <>  0 ) 
 then goto _570;
K := 0;
for I:=1 to N do
 begin
  for J:=1 to I do
   begin
    K := K + 1;
    WORK[K-1] := XJTJ[K-1];
_550:
   end;
  ICAL1I := ISCAL1 + I;
  WORK[K-1] := ONEP5*(XJTJ[K-1] + AL*ERL2*WORK[ICAL1I-1]) + REL;
_560:
 end;
IBAD := 2;
goto _310;
_570:
IZERO := 0;
for J:=ISCALL to ISCALU do
 begin
  if ( WORK[J-1] >  ZERO ) 
   then goto _580;
  IZERO := IZERO + 1;
  WORK[J-1] := ONE;
_580:
 end;
if ( IZERO <  N ) 
 then goto _280;
IER := 38;
goto _640;
_590:
IER := IER + 1;
_600:
IER := IER + 1;
_610:
IER := IER + 1;
_620:
IER := IER + 1;
_630:
IER := IER + 129;
if ( IER =  130 ) 
 then goto _690;
_640:
WORK[0] := ERL2 + ERL2;
WORK[1] := IEVAL;
SSQ := SSQOLD;
G := SIG;
for J:=1 to N do
 begin
  IELX1J := IDELX1 + J;
  XHOLD := Abs(WORK[IELX1J-1]);
  if ( XHOLD <=  ZERO ) 
   then goto _650;
  G := EMin1(G,-Log10(XHOLD/EMax1(AX,Abs(X[J-1]))));
_650:
 end;
WORK[2] := G;
WORK[3] := AL;
WORK[4] := ITER;
if ( IXJAC =  M ) 
 then goto _680;
LI := N - 1;
K := LI*M;
IR := LI*IXJAC;
for J:=1 to N do
 begin
  if ( J =  N ) 
   then goto _670;
  for I:=1 to M do
   begin
    IRI := IR + I;
    KI := K + I;
    XJAC[IRI-1] := XJAC[KI-1];
_660:
   end;
  K := K - M;
  IR := IR - IXJAC;
_670:
 end;
_680:
if ( IER =  0 ) 
 then goto _700;
_690:
_700:
end;

end.
